<template>
  <b-card :shadow="2" class="w-360 w-max-100p mt-6x">
    <h2>Sign in</h2>
    <form class="mt-2x" @submit.prevent="handleUserLogin">
      <b-form-item label="Email" :error="$validationMessage('email', $v.email)">
        <b-input v-model.trim="email" placeholder="Enter your email" />
      </b-form-item>
      <b-form-item
        label="Password"
        :error="$validationMessage('password', $v.password)"
      >
        <b-input
          v-model.trim="password"
          placeholder="Enter your password"
          show-password
        />
      </b-form-item>
      <b-inline-message v-if="error" error class="mt-4x">
        <p>{{ error }}</p>
      </b-inline-message>
      <div class="mt-4x">
        <b-button-text small @click.prevent="$router.push('forgot-password')"
          >Forgot your password?</b-button-text
        >
      </div>
      <div class="d-flex content-end mt-6x">
        <b-button type="submit" primary suffix-icon="arrow-right"
          >Access</b-button
        >
      </div>
    </form>
  </b-card>
</template>

<script lang="ts">
import Vue from 'vue'
import { mapActions } from 'vuex'
import { required, email } from 'vuelidate/lib/validators'
// import { required } from 'vuelidate/lib/validators'

export default Vue.extend({
  name: 'LoginPage',
  auth: 'guest',
  data() {
    return {
      email: '',
      password: '',
      error: '',
    }
  },
  validations: {
    email: {
      required,
      email,
    },
    password: {
      required,
    },
  },
  methods: {
    ...mapActions('common', ['setLoading']),
    async handleUserLogin() {
      this.$v.$touch()
      if (!this.$v.$invalid) {
        try {
          this.setLoading(true)
          // Log user in
          await this.$auth.loginWith('local', {
            data: {
              username: this.email,
              password: this.password,
            },
          })

          // Set user's preffered language
          // if (this.$auth.user && this.$auth.user.preferencedLang) {
          //   const locale = this.$i18n.locales.find(
          //     (locale) => locale.iso === this.$auth.user.preferencedLang
          //   )

          //   if (locale) {
          //     this.$i18n.setLocale(locale.code)
          //   }
          // }
        } catch (error) {
          this.error = 'Your account information was entered incorrectly.'
        } finally {
          this.setLoading(false)
        }
      }
    },
  },
})
</script>
